package com.zipcodewilmington.singlylinkedlist;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList {
    private Node head;
    Node current = head;

static public class Node{
    Integer data;
    Node next;

        public Node(Integer inData, Node next){
            this.data = inData;
            this.next = next;
        }
}
    public Node getHead(){
    return head;
    }


public void setHead( Node head){
    this.head = head;
    }

public void appendNode( Integer inData){
    current = head;
    Node newNode = new Node(inData, null);
    if(this.head == null) {
        setHead(newNode);
    } else{
        while (current.next !=null) {
            current = current.next;
        }
        current.next = newNode;
    }
}

    public void prependNode(Integer inData) {
        if (this.head == null) {
            Node newNode = new Node(inData, null);
            this.head = newNode;
        } else {
            Node newNode = new Node(inData, head);
            this.head = newNode;
        }
    }

    public void remove(Integer index){
    current = head;
    if(index == 0){
        setHead(head.next);
    }
    int count =0;
    while(current!= null && count <index -1) {
        count++;
        current = current.next;
        }
        if (current == null || current.next ==null)
            return;
        current.next = current.next.next;
    }

    public boolean contains(Integer inData) {
        current = head;
        while(current != null) {
            if(current.data == inData)
                return true;
            current = current.next;
        }
        return false;
    }

    public int getIndex(Integer inData){
            current = head;
            int count =0;
            while(current != null) {
                if (current.data == inData) {
                    return count;
                }
                count++;
                current = current.next;
            }
            assert (false);
            return -1;
            }

    public Integer getDataAtNthIndex(Integer index){
        current = head;
            int count = 0;
            while (current != null) {
             if (count == index) {
                return current.data;
                 }
           count++;
             current = current.next;
           }
            assert (false);
                return -1;


         }

    public Integer getSize() {
      current = head;
      int count = 0;
       while (current != null) {
          count++;
          current = current.next;
           }
        return count;
        }



    public SinglyLinkedList getCopy() {
             current = head;
         SinglyLinkedList newList = new SinglyLinkedList();
        newList.setHead(this.head);
        while (newList.getSize() < this.getSize()) {
            newList.appendNode(current.data);
          }
     return newList;
       }

    public void sortList(){
       Integer size = this.getSize();
       for(int i = 0; i < size; i++){
       current = head;
         current.next = head.next;
        for(int j = 0; j < size -1; j++){
        if(current.data > current.next.data){
        Integer temp = current.data;
         current.data = current.next.data;
        current.next.data = temp;
              }
           current = current.next;
         }
       }
   }
    @Override
    public String toString() {
     current = head;
      String word = new String();
       while(current != null){
          word += "" + current.data;
          current = current.next;
            }
     return "SinglyLinkedList{" + word;

 }


}




