package com.zipcodewilmington.singlylinkedlist;

import junit.framework.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedListTest {
    private static final junit.framework.Assert Assert = null;


    @Test

    public void testAppendNode(){
       //Given
        SinglyLinkedList myList = new SinglyLinkedList();
          //When

        myList.appendNode(0);
       myList.appendNode(1);
        myList.appendNode(2);
       Integer expNode = 2;
       Integer actNode = myList.getHead().next.next.data;

       //Then
     Assert.assertEquals(expNode,actNode);
         }
    @Test
    public void testPrependNode(){
                //Given
            SinglyLinkedList myList = new SinglyLinkedList();
            SinglyLinkedList.Node node1 = new SinglyLinkedList.Node(0,null);
                //When
              myList.setHead(node1);
              myList.appendNode(1);
              myList.prependNode(2);
              SinglyLinkedList.Node expNextNode = node1;
              SinglyLinkedList.Node actNextNode = myList.getHead().next;
                //Then
              Assert.assertEquals(expNextNode,actNextNode);
        }

    @Test
            public void removeNode(){
                //Given
           SinglyLinkedList myList = new SinglyLinkedList();
           SinglyLinkedList.Node node1 = new SinglyLinkedList.Node(0,null);
                //When
           myList.setHead(node1);
           myList.appendNode(1);
           myList.prependNode(2);
           myList.appendNode(3);
           myList.remove(2);
           Integer expSize = 3;
           Integer actSize = myList.getSize();
                //Then
           Assert.assertEquals(expSize,actSize);
            }
}
